//
//  ViewController.m
//  SearchCityDemo
//
//  Created by 阳光 on 16/7/8.
//  Copyright © 2016年 com_qibei. All rights reserved.
//

#import "ViewController.h"
#import "RequestTool.h"
#import "CityListCell.h"
#import "CityModel.h"

@interface ViewController ()<UITableViewDataSource,UITableViewDelegate,UISearchBarDelegate>

@property(nonatomic,strong)UITableView *tableView;

@property(nonatomic,strong)NSMutableArray *dataArr;

@property(nonatomic,strong)NSMutableDictionary *city_LetterDic;

@property(nonatomic,strong)NSMutableArray *searchArr;

@property(nonatomic,strong)UISearchBar *searchBar;


@end

@implementation ViewController

#pragma mark -UISearchBar Delegate
-(void)searchBar:(UISearchBar *)searchBar textDidChange:(NSString *)searchText
{
    // 有编辑内容时为YES即搜索,否则不搜索
    BOOL IsSearch=YES;
    if (searchText.length<=0) {
        // 被清空时为NO
        IsSearch=NO;
    }

    // 清空_searchArr,防止显示之前搜索的结果内容
    [_searchArr removeAllObjects];

    NSString *searchTextStr=_searchBar.text;

    // 让搜索文本内容与数据源进行比较,取出数据源类似数据,然后存入到_searchArr中
    for (NSInteger i=0;i<_dataArr.count;i++)
    {
        CityModel *cityModel=_dataArr[i];

        // 转小写
        searchTextStr=[searchTextStr lowercaseString];

       // 判断cityModel.city_name是否以字符串searchTextStr开头
        BOOL IsHas=[cityModel.city_name hasPrefix:searchTextStr];

        if (IsHas)
        {
            [_searchArr addObject:cityModel];
        }
        else
        {
            IsHas=[cityModel.city_pinyin hasPrefix:searchTextStr];
            if (IsHas)
            {
                [_searchArr addObject:cityModel];
            }
        }
    }


    if (searchTextStr.length>0)
    {
        [_city_LetterDic removeAllObjects];

        // 遍历
        for (CityModel *cityModel in _searchArr)
        {
            NSMutableArray *letterArr=_city_LetterDic[cityModel.m_letter];

            // 判断数组里是否有元素,如果为nil,则实例化该数组
            if (letterArr==nil)
            {
                letterArr=[[NSMutableArray alloc]init];
            [_city_LetterDic setObject:letterArr forKey:cityModel.m_letter];
            }

            [letterArr addObject:cityModel];
        }
    }
    else
    {
        // 遍历
        for (CityModel *cityModel in _dataArr)
        {
            NSMutableArray *letterArr=_city_LetterDic[cityModel.m_letter];
            // 判断数组里是否有元素,如果为nil,则实例化该数组
            if (letterArr==nil)
            {
                letterArr=[[NSMutableArray alloc]init];
                [_city_LetterDic setObject:letterArr forKey:cityModel.m_letter];
            }
            [letterArr addObject:cityModel];
        }
    }

    [_tableView reloadData];
}


- (void)viewDidLoad {
    [super viewDidLoad];

    [self setUpView];
}

-(void)Get_LoadRequest
{
  NSString *urlStr =@"http://apis.baidu.com/baidunuomi/openapi/cities";

    // 一种方式 键值
    NSDictionary *dict=@{
        @"apikey":@"2304cdaee07aa52690475edf3776cce6"
       };

   // 更一种方式
//    NSMutableDictionary *headDict = [[NSMutableDictionary alloc] init];
//    [headDict setObject:@"2304cdaee07aa52690475edf3776cce6" forKey:@"apikey"];

    [RequestTool GetCallBack:urlStr parameter:nil headerDic:dict success:^(id responseObj) {
//        NSLog(@"responseObj==---%@",responseObj);
        for (NSDictionary *dic in responseObj[@"cities"]) {
            CityModel *cityModel=[[CityModel alloc]init];
            // 城市id
            cityModel.city_id=dic[@"city_id"];
            // 城市名字
            cityModel.city_name=dic[@"city_name"];
            // 城市拼音
            cityModel.city_pinyin=dic[@"city_pinyin"];
            // 城市名简称
            cityModel.short_name=dic[@"short_name"];
            // 城市拼音简称
            cityModel.short_pinyin=dic[@"short_pinyin"];

            // 首字母转大写字母  uppercaseString 转大写  lowerCaseString转小写
            cityModel.m_letter=[[cityModel.city_pinyin substringWithRange:NSMakeRange(0,1)]uppercaseString];
            [_dataArr addObject:cityModel];
        }
        // 从网络加载数据存在时,保存到本地
        if (_dataArr.count>0)
        {
            [self saveToLocal];
        }

        [self Get_FirstCity];

        // 刷新数据视图
        [_tableView reloadData];

    } failure:^(NSError *error) {

    }];
}

// 把数据保存到本地
-(void)saveToLocal
{
    NSMutableArray *arr=[NSMutableArray array];
    for (NSDictionary *dic in _dataArr) {
        [arr addObject:dic];
    }
    // 保存到本地中
    [arr writeToFile:[kDocumentPath stringByAppendingPathComponent:@"CityList.plist"] atomically:YES] ;
}


-(void)loadFromLocal
{
    // 清空数组中的元素
    [_dataArr removeAllObjects];

    // 获取本地数据,放到数组中
    NSMutableArray *arr=[NSMutableArray arrayWithContentsOfFile:[kDocumentPath   stringByAppendingPathComponent:@"CityList.plist"]];

    for (NSDictionary *dic in arr) {
        [_dataArr addObject:dic];
    }

    for (NSDictionary *dic in _dataArr) {
        CityModel *cityModel=[[CityModel alloc]init];
        cityModel.city_id=dic[@"city_id"];
        cityModel.city_name=dic[@"city_name"];
        cityModel.city_pinyin=dic[@"city_pinyin"];

        cityModel.short_name=dic[@"short_name"];
        cityModel.short_pinyin=dic[@"short_pinyin"];

        cityModel.m_letter=[[cityModel.city_pinyin substringWithRange:NSMakeRange(0,1)]uppercaseString];
        [_dataArr addObject:cityModel];
    }
}

- (void)onHideKeyboard
{
    [self.view endEditing:NO];
}

-(void)setUpView
{
    // 搜索按钮
    _searchBar=[[UISearchBar alloc]initWithFrame:CGRectMake(0,0,APPW,kmargin*4)];
    _searchBar.delegate=self;
    _searchBar.backgroundColor=[UIColor clearColor];
    _searchBar.placeholder=@"请输入城市中文名或者拼音";
    _searchBar.searchBarStyle=UISearchBarStyleMinimal;
    self.navigationItem.titleView=_searchBar;

    // 初始化数据
    _dataArr =[NSMutableArray array];
    _city_LetterDic=[[NSMutableDictionary alloc]init];
    _searchArr=[NSMutableArray array];

    // _tableView
    _tableView=[[UITableView alloc]initWithFrame:CGRectMake(0,0,APPW, APPH) style:UITableViewStylePlain];
    _tableView.delegate=self;
    _tableView.dataSource=self;
    _tableView.backgroundColor=[UIColor whiteColor];
    [self.view addSubview:_tableView];


    // 把分割线重新设置  置前
    if ([_tableView respondsToSelector:@selector(setSeparatorInset:)]) {
        [_tableView setSeparatorInset:UIEdgeInsetsZero];
    }
    if ([_tableView respondsToSelector:@selector(setLayoutMargins:)]) {
        [_tableView setLayoutMargins:UIEdgeInsetsZero];
    }

    // 先判断本地是否有,如果没,就从网络加载,然后存到本地,下次再打开时直接从本地获取
    [self loadFromLocal];

    if (_dataArr.count>0)
    {
        // 将首字母相同的放在一起
        [self Get_FirstCity];

        [_tableView reloadData];
    }
    else
    {
        // 数据请求
        [self Get_LoadRequest];
    }
}

-(void)Get_FirstCity
{
   // 遍历
    for (CityModel *cityModel in _dataArr)
    {
         // letterArr存放首字母大写数组
        NSMutableArray *letterArr=_city_LetterDic[cityModel.m_letter];
        // 判断数组中是否有元素,如果没,则实例化该数组,并在city_LetterDic字典中插入一条新的数据
        if (letterArr==nil) {
            letterArr=[[NSMutableArray alloc]init];
            [_city_LetterDic setObject:letterArr forKey:cityModel.m_letter];
        }
        // 将新的数据放到数组里
        [letterArr addObject:cityModel];
    }
}

// 获取所有的key值并排序,且返回排好序的数组
-(NSArray *)getCityDicAllKeys
{
    // 获取city_LetterDic字典里所有key值 :[_city_LetterDic allKeys]
    return [[_city_LetterDic allKeys] sortedArrayUsingSelector:@selector(compare:)];
}

// 获取section的个数
-(NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return [self getCityDicAllKeys].count;
}

// 每个section对应的cell个数
-(NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section
{
    // 获取所有的key值
    NSArray *keys=[self getCityDicAllKeys];
    NSString *keyStr=keys[section];
    NSArray *arr=_city_LetterDic[keyStr];
    return arr.count;
}

// section上的标题
-(NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section
{
    NSArray *keys=[self getCityDicAllKeys];
    return keys[section];
}

// 引入索引的一个代理方法
-(NSArray<NSString *> *)sectionIndexTitlesForTableView:(UITableView *)tableView
{
    return [self getCityDicAllKeys];
}

-(UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath
{
    static NSString *str=@"CityListCell";
    CityListCell *cell=[tableView dequeueReusableCellWithIdentifier:str];
    if (cell==nil) {
        cell=[[CityListCell alloc]initWithStyle:UITableViewCellStyleDefault reuseIdentifier:str];
    }
    NSArray *keys=[self getCityDicAllKeys];
    NSString *keyStr=keys[indexPath.section];
    CityModel *cityModel=_city_LetterDic[keyStr][indexPath.row];
    [cell setCityModel:cityModel];
    return cell;
}

-(void)tableView:(UITableView *)tableView willDisplayCell:(UITableViewCell *)cell forRowAtIndexPath:(NSIndexPath *)indexPath
{
    if ([cell respondsToSelector:@selector(setSeparatorInset:)]) {
        [cell setSeparatorInset:UIEdgeInsetsZero];
    }
    if ([cell respondsToSelector:@selector(setLayoutMargins:)]) {
        [cell setLayoutMargins:UIEdgeInsetsZero];
    }
}

- (void)didReceiveMemoryWarning {
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
